import { Inject, Singleton } from "../../src/Decorator"
import { Initializable } from "../../src/Interfaces"
import { COMPONENT_B_VALUE } from "../CONSTANTS"
import { TestComponent } from "./TestComponent"

@Singleton({
    initializationPriority: 2
})
export class ComponentB implements Initializable{
    @Inject(TestComponent)
    private testComponent: TestComponent

    initialize(): void{
        this.testComponent.pushData(COMPONENT_B_VALUE)
    }
}